package sequenze;

public class ArraySequenza<T>
implements Sequenza<T>
{
	T[] seq;
	int curr = 0;

	public ArraySequenza(int size)
	{
		seq = (T[])(new Object[size]);
	}

	public ArraySequenza(T[] objs)
	{
		this(objs.length);
		int i = 0;
		for(i=0;i<objs.length;i++)
		{
			seq[i] = objs[i];
		}
	}

	public T get(int index)
	{
		return seq[index];
	}

	public int size()
	{
		return curr;
	}

	public T set(int index, T element)
	{
		T retval = seq[index];
		seq[index]=element;
		return retval;
	}

	public boolean add(T element)
	{
		if(curr >= seq.length)
		{
			return false;
		}
		set(curr++, element);
		return true;
	}

	public SeqIterator<T> seqIterator()
	{
		SeqIterator<T> retval = new ArraySeqIterator<T>(this);;
		return retval;
	}
}
